/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.349 Revision 1.369
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.349 2010/08/19 21:32:26 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.369 2011/12/02 03:27:37 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18inherit multilib portability user
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21 21
22if has "${EAPI:-0}" 0 1 2; then 22if has "${EAPI:-0}" 0 1 2; then
23 23
64fi 64fi
65 65
66# @FUNCTION: eqawarn 66# @FUNCTION: eqawarn
67# @USAGE: [message] 67# @USAGE: [message]
68# @DESCRIPTION: 68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM 69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. 70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
71if ! declare -F eqawarn >/dev/null ; then 72if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() { 73 eqawarn() {
73 einfo "$@" 74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
74 } 75 }
75fi 76fi
76 77
77# @FUNCTION: ecvs_clean 78# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs] 79# @USAGE: [list of dirs]
200# If you do not specify any options, then epatch will default to the directory 201# If you do not specify any options, then epatch will default to the directory
201# specified by EPATCH_SOURCE. 202# specified by EPATCH_SOURCE.
202# 203#
203# When processing directories, epatch will apply all patches that match: 204# When processing directories, epatch will apply all patches that match:
204# @CODE 205# @CODE
205# ${EPATCH_FORCE} == "yes" 206# if ${EPATCH_FORCE} != "yes"
206# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else 208# else
208# *.${EPATCH_SUFFIX} 209# *.${EPATCH_SUFFIX}
209# @CODE 210# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering. 211# The leading ?? are typically numbers used to force consistent patch ordering.
249 local EPATCH_SUFFIX=$1 250 local EPATCH_SUFFIX=$1
250 251
251 elif [[ -d $1 ]] ; then 252 elif [[ -d $1 ]] ; then
252 # Some people like to make dirs of patches w/out suffixes (vim) 253 # Some people like to make dirs of patches w/out suffixes (vim)
253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"} 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
254 260
255 else 261 else
256 # sanity check ... if it isn't a dir or file, wtf man ? 262 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1 263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo 264 echo
289 # ???_arch_foo.patch 295 # ???_arch_foo.patch
290 # Else, skip this input altogether 296 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_ 297 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch 298 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \ 299 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \ 300 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \ 301 ${a} == all || \
296 ${a} == ${ARCH} ]] 302 ${a} == ${ARCH} ]]
297 then 303 then
298 continue 304 continue
299 fi 305 fi
300 306
301 # Let people filter things dynamically 307 # Let people filter things dynamically
329 local STDERR_TARGET="${T}/${patchname}.out" 335 local STDERR_TARGET="${T}/${patchname}.out"
330 if [[ -e ${STDERR_TARGET} ]] ; then 336 if [[ -e ${STDERR_TARGET} ]] ; then
331 STDERR_TARGET="${T}/${patchname}-$$.out" 337 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi 338 fi
333 339
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}" 340 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
335 341
336 # Decompress the patch if need be 342 # Decompress the patch if need be
337 local count=0 343 local count=0
338 local PATCH_TARGET 344 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then 345 if [[ -n ${PIPE_CMD} ]] ; then
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }') 364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then 365 if [[ -n ${abs_paths} ]] ; then
360 count=1 366 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}" 367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi 368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
363 376
364 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/ 377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
365 while [[ ${count} -lt 5 ]] ; do 378 while [[ ${count} -lt 5 ]] ; do
366 # Generate some useful debug info ... 379 # Generate some useful debug info ...
367 ( 380 (
368 _epatch_draw_line "***** ${patchname} *****" 381 _epatch_draw_line "***** ${patchname} *****"
369 echo 382 echo
370 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
371 echo 384 echo
372 _epatch_draw_line "***** ${patchname} *****" 385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
373 ) >> "${STDERR_TARGET}" 391 ) >> "${STDERR_TARGET}"
374 392
375 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then 393 if [ $? -eq 0 ] ; then
376 ( 394 (
377 _epatch_draw_line "***** ${patchname} *****" 395 _epatch_draw_line "***** ${patchname} *****"
378 echo 396 echo
379 echo "ACTUALLY APPLYING ${patchname} ..." 397 echo "ACTUALLY APPLYING ${patchname} ..."
380 echo 398 echo
381 _epatch_draw_line "***** ${patchname} *****" 399 _epatch_draw_line "***** ${patchname} *****"
382 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1 400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
383 ) >> "${STDERR_TARGET}" 405 ) >> "${STDERR_TARGET}"
384 406
385 if [ $? -ne 0 ] ; then 407 if [ $? -ne 0 ] ; then
386 echo 408 echo
387 eerror "A dry-run of patch command succeeded, but actually" 409 eerror "A dry-run of patch command succeeded, but actually"
418 done 440 done
419 441
420 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching" 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
421 : # everything worked 443 : # everything worked
422} 444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
423epatch_user() { 472epatch_user() {
424 [[ $# -ne 0 ]] && die "epatch_user takes no options" 473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
425 478
426 # don't clobber any EPATCH vars that the parent might want 479 # don't clobber any EPATCH vars that the parent might want
427 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches 480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
428 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do 481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
429 EPATCH_SOURCE=${base}/${CTARGET}/${check} 482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
433 EPATCH_SOURCE=${EPATCH_SOURCE} \ 486 EPATCH_SOURCE=${EPATCH_SOURCE} \
434 EPATCH_SUFFIX="patch" \ 487 EPATCH_SUFFIX="patch" \
435 EPATCH_FORCE="yes" \ 488 EPATCH_FORCE="yes" \
436 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \ 489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
437 epatch 490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
438 return 0 492 return 0
439 fi 493 fi
440 done 494 done
495 echo "none" > "${applied}"
441 return 1 496 return 1
442} 497}
443 498
444# @FUNCTION: emktemp 499# @FUNCTION: emktemp
445# @USAGE: [temp dir] 500# @USAGE: [temp dir]
474 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
475 fi 530 fi
476 fi 531 fi
477} 532}
478 533
479# @FUNCTION: egetent
480# @USAGE: <database> <key>
481# @MAINTAINER:
482# base-system@gentoo.org (Linux)
483# Joe Jezak <josejx@gmail.com> (OS X)
484# usata@gentoo.org (OS X)
485# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
486# @DESCRIPTION:
487# Small wrapper for getent (Linux),
488# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
489# and pw (FreeBSD) used in enewuser()/enewgroup()
490egetent() {
491 case ${CHOST} in
492 *-darwin[678])
493 case "$2" in
494 *[!0-9]*) # Non numeric
495 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
496 ;;
497 *) # Numeric
498 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
499 ;;
500 esac
501 ;;
502 *-darwin*)
503 local mytype=$1
504 [[ "passwd" == $mytype ]] && mytype="Users"
505 [[ "group" == $mytype ]] && mytype="Groups"
506 case "$2" in
507 *[!0-9]*) # Non numeric
508 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
509 ;;
510 *) # Numeric
511 local mykey="UniqueID"
512 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
513 dscl . -search /$mytype $mykey $2 2>/dev/null
514 ;;
515 esac
516 ;;
517 *-freebsd*|*-dragonfly*)
518 local opts action="user"
519 [[ $1 == "passwd" ]] || action="group"
520
521 # lookup by uid/gid
522 if [[ $2 == [[:digit:]]* ]] ; then
523 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
524 fi
525
526 pw show ${action} ${opts} "$2" -q
527 ;;
528 *-netbsd*|*-openbsd*)
529 grep "$2:\*:" /etc/$1
530 ;;
531 *)
532 type -p nscd >& /dev/null && nscd -i "$1"
533 getent "$1" "$2"
534 ;;
535 esac
536}
537
538# @FUNCTION: enewuser
539# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
540# @DESCRIPTION:
541# Same as enewgroup, you are not required to understand how to properly add
542# a user to the system. The only required parameter is the username.
543# Default uid is (pass -1 for this) next available, default shell is
544# /bin/false, default homedir is /dev/null, there are no default groups,
545# and default params sets the comment as 'added by portage for ${PN}'.
546enewuser() {
547 case ${EBUILD_PHASE} in
548 unpack|compile|test|install)
549 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
550 eerror "Package fails at QA and at life. Please file a bug."
551 die "Bad package! enewuser is only for use in pkg_* functions!"
552 esac
553
554 # get the username
555 local euser=$1; shift
556 if [[ -z ${euser} ]] ; then
557 eerror "No username specified !"
558 die "Cannot call enewuser without a username"
559 fi
560
561 # lets see if the username already exists
562 if [[ -n $(egetent passwd "${euser}") ]] ; then
563 return 0
564 fi
565 einfo "Adding user '${euser}' to your system ..."
566
567 # options to pass to useradd
568 local opts=
569
570 # handle uid
571 local euid=$1; shift
572 if [[ -n ${euid} && ${euid} != -1 ]] ; then
573 if [[ ${euid} -gt 0 ]] ; then
574 if [[ -n $(egetent passwd ${euid}) ]] ; then
575 euid="next"
576 fi
577 else
578 eerror "Userid given but is not greater than 0 !"
579 die "${euid} is not a valid UID"
580 fi
581 else
582 euid="next"
583 fi
584 if [[ ${euid} == "next" ]] ; then
585 for ((euid = 101; euid <= 999; euid++)); do
586 [[ -z $(egetent passwd ${euid}) ]] && break
587 done
588 fi
589 opts="${opts} -u ${euid}"
590 einfo " - Userid: ${euid}"
591
592 # handle shell
593 local eshell=$1; shift
594 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
595 if [[ ! -e ${ROOT}${eshell} ]] ; then
596 eerror "A shell was specified but it does not exist !"
597 die "${eshell} does not exist in ${ROOT}"
598 fi
599 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
600 eerror "Do not specify ${eshell} yourself, use -1"
601 die "Pass '-1' as the shell parameter"
602 fi
603 else
604 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
605 [[ -x ${ROOT}${shell} ]] && break
606 done
607
608 if [[ ${shell} == "/dev/null" ]] ; then
609 eerror "Unable to identify the shell to use, proceeding with userland default."
610 case ${USERLAND} in
611 GNU) shell="/bin/false" ;;
612 BSD) shell="/sbin/nologin" ;;
613 Darwin) shell="/usr/sbin/nologin" ;;
614 *) die "Unable to identify the default shell for userland ${USERLAND}"
615 esac
616 fi
617
618 eshell=${shell}
619 fi
620 einfo " - Shell: ${eshell}"
621 opts="${opts} -s ${eshell}"
622
623 # handle homedir
624 local ehome=$1; shift
625 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
626 ehome="/dev/null"
627 fi
628 einfo " - Home: ${ehome}"
629 opts="${opts} -d ${ehome}"
630
631 # handle groups
632 local egroups=$1; shift
633 if [[ ! -z ${egroups} ]] ; then
634 local oldifs=${IFS}
635 local defgroup="" exgroups=""
636
637 export IFS=","
638 for g in ${egroups} ; do
639 export IFS=${oldifs}
640 if [[ -z $(egetent group "${g}") ]] ; then
641 eerror "You must add group ${g} to the system first"
642 die "${g} is not a valid GID"
643 fi
644 if [[ -z ${defgroup} ]] ; then
645 defgroup=${g}
646 else
647 exgroups="${exgroups},${g}"
648 fi
649 export IFS=","
650 done
651 export IFS=${oldifs}
652
653 opts="${opts} -g ${defgroup}"
654 if [[ ! -z ${exgroups} ]] ; then
655 opts="${opts} -G ${exgroups:1}"
656 fi
657 else
658 egroups="(none)"
659 fi
660 einfo " - Groups: ${egroups}"
661
662 # handle extra and add the user
663 local oldsandbox=${SANDBOX_ON}
664 export SANDBOX_ON="0"
665 case ${CHOST} in
666 *-darwin*)
667 ### Make the user
668 if [[ -z $@ ]] ; then
669 dscl . create /users/${euser} uid ${euid}
670 dscl . create /users/${euser} shell ${eshell}
671 dscl . create /users/${euser} home ${ehome}
672 dscl . create /users/${euser} realname "added by portage for ${PN}"
673 ### Add the user to the groups specified
674 local oldifs=${IFS}
675 export IFS=","
676 for g in ${egroups} ; do
677 dscl . merge /groups/${g} users ${euser}
678 done
679 export IFS=${oldifs}
680 else
681 einfo "Extra options are not supported on Darwin yet"
682 einfo "Please report the ebuild along with the info below"
683 einfo "eextra: $@"
684 die "Required function missing"
685 fi
686 ;;
687 *-freebsd*|*-dragonfly*)
688 if [[ -z $@ ]] ; then
689 pw useradd ${euser} ${opts} \
690 -c "added by portage for ${PN}" \
691 die "enewuser failed"
692 else
693 einfo " - Extra: $@"
694 pw useradd ${euser} ${opts} \
695 "$@" || die "enewuser failed"
696 fi
697 ;;
698
699 *-netbsd*)
700 if [[ -z $@ ]] ; then
701 useradd ${opts} ${euser} || die "enewuser failed"
702 else
703 einfo " - Extra: $@"
704 useradd ${opts} ${euser} "$@" || die "enewuser failed"
705 fi
706 ;;
707
708 *-openbsd*)
709 if [[ -z $@ ]] ; then
710 useradd -u ${euid} -s ${eshell} \
711 -d ${ehome} -c "Added by portage for ${PN}" \
712 -g ${egroups} ${euser} || die "enewuser failed"
713 else
714 einfo " - Extra: $@"
715 useradd -u ${euid} -s ${eshell} \
716 -d ${ehome} -c "Added by portage for ${PN}" \
717 -g ${egroups} ${euser} "$@" || die "enewuser failed"
718 fi
719 ;;
720
721 *)
722 if [[ -z $@ ]] ; then
723 useradd -r ${opts} \
724 -c "added by portage for ${PN}" \
725 ${euser} \
726 || die "enewuser failed"
727 else
728 einfo " - Extra: $@"
729 useradd -r ${opts} "$@" \
730 ${euser} \
731 || die "enewuser failed"
732 fi
733 ;;
734 esac
735
736 if [[ ! -e ${ROOT}/${ehome} ]] ; then
737 einfo " - Creating ${ehome} in ${ROOT}"
738 mkdir -p "${ROOT}/${ehome}"
739 chown ${euser} "${ROOT}/${ehome}"
740 chmod 755 "${ROOT}/${ehome}"
741 fi
742
743 export SANDBOX_ON=${oldsandbox}
744}
745
746# @FUNCTION: enewgroup
747# @USAGE: <group> [gid]
748# @DESCRIPTION:
749# This function does not require you to understand how to properly add a
750# group to the system. Just give it a group name to add and enewgroup will
751# do the rest. You may specify the gid for the group or allow the group to
752# allocate the next available one.
753enewgroup() {
754 case ${EBUILD_PHASE} in
755 unpack|compile|test|install)
756 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
757 eerror "Package fails at QA and at life. Please file a bug."
758 die "Bad package! enewgroup is only for use in pkg_* functions!"
759 esac
760
761 # get the group
762 local egroup="$1"; shift
763 if [ -z "${egroup}" ]
764 then
765 eerror "No group specified !"
766 die "Cannot call enewgroup without a group"
767 fi
768
769 # see if group already exists
770 if [[ -n $(egetent group "${egroup}") ]]; then
771 return 0
772 fi
773 einfo "Adding group '${egroup}' to your system ..."
774
775 # options to pass to useradd
776 local opts=
777
778 # handle gid
779 local egid="$1"; shift
780 if [ ! -z "${egid}" ]
781 then
782 if [ "${egid}" -gt 0 ]
783 then
784 if [ -z "`egetent group ${egid}`" ]
785 then
786 if [[ "${CHOST}" == *-darwin* ]]; then
787 opts="${opts} ${egid}"
788 else
789 opts="${opts} -g ${egid}"
790 fi
791 else
792 egid="next available; requested gid taken"
793 fi
794 else
795 eerror "Groupid given but is not greater than 0 !"
796 die "${egid} is not a valid GID"
797 fi
798 else
799 egid="next available"
800 fi
801 einfo " - Groupid: ${egid}"
802
803 # handle extra
804 local eextra="$@"
805 opts="${opts} ${eextra}"
806
807 # add the group
808 local oldsandbox="${SANDBOX_ON}"
809 export SANDBOX_ON="0"
810 case ${CHOST} in
811 *-darwin*)
812 if [ ! -z "${eextra}" ];
813 then
814 einfo "Extra options are not supported on Darwin/OS X yet"
815 einfo "Please report the ebuild along with the info below"
816 einfo "eextra: ${eextra}"
817 die "Required function missing"
818 fi
819
820 # If we need the next available
821 case ${egid} in
822 *[!0-9]*) # Non numeric
823 for ((egid = 101; egid <= 999; egid++)); do
824 [[ -z $(egetent group ${egid}) ]] && break
825 done
826 esac
827 dscl . create /groups/${egroup} gid ${egid}
828 dscl . create /groups/${egroup} passwd '*'
829 ;;
830
831 *-freebsd*|*-dragonfly*)
832 case ${egid} in
833 *[!0-9]*) # Non numeric
834 for ((egid = 101; egid <= 999; egid++)); do
835 [[ -z $(egetent group ${egid}) ]] && break
836 done
837 esac
838 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
839 ;;
840
841 *-netbsd*)
842 case ${egid} in
843 *[!0-9]*) # Non numeric
844 for ((egid = 101; egid <= 999; egid++)); do
845 [[ -z $(egetent group ${egid}) ]] && break
846 done
847 esac
848 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
849 ;;
850
851 *)
852 # We specify -r so that we get a GID in the system range from login.defs
853 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
854 ;;
855 esac
856 export SANDBOX_ON="${oldsandbox}"
857}
858
859# @FUNCTION: edos2unix 534# @FUNCTION: edos2unix
860# @USAGE: <file> [more files ...] 535# @USAGE: <file> [more files ...]
861# @DESCRIPTION: 536# @DESCRIPTION:
862# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 537# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
863# to remove all of these text utilities from DEPEND variables because this 538# to remove all of these text utilities from DEPEND variables because this
864# is a script based solution. Just give it a list of files to convert and 539# is a script based solution. Just give it a list of files to convert and
865# they will all be changed from the DOS CRLF format to the UNIX LF format. 540# they will all be changed from the DOS CRLF format to the UNIX LF format.
866edos2unix() { 541edos2unix() {
867 echo "$@" | xargs sed -i 's/\r$//' 542 [[ $# -eq 0 ]] && return 0
543 sed -i 's/\r$//' -- "$@" || die
868} 544}
869 545
870# Make a desktop file ! 546# Make a desktop file !
871# Great for making those icons in kde/gnome startmenu ! 547# Great for making those icons in kde/gnome startmenu !
872# Amaze your friends ! Get the women ! Join today ! 548# Amaze your friends ! Get the women ! Join today !
1384 dd) exe="dd ibs=${skip} skip=1 if='${src}'";; 1060 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1385 *) die "makeself cant handle exe '${exe}'" 1061 *) die "makeself cant handle exe '${exe}'"
1386 esac 1062 esac
1387 1063
1388 # lets grab the first few bytes of the file to figure out what kind of archive it is 1064 # lets grab the first few bytes of the file to figure out what kind of archive it is
1389 local tmpfile=$(emktemp) 1065 local filetype tmpfile=$(emktemp)
1390 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1066 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1391 local filetype=$(file -b "${tmpfile}") 1067 filetype=$(file -b "${tmpfile}") || die
1392 case ${filetype} in 1068 case ${filetype} in
1393 *tar\ archive*) 1069 *tar\ archive*)
1394 eval ${exe} | tar --no-same-owner -xf - 1070 eval ${exe} | tar --no-same-owner -xf -
1395 ;; 1071 ;;
1396 bzip2*) 1072 bzip2*)
1706 else 1382 else
1707 newls="" 1383 newls=""
1708 fi 1384 fi
1709 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1385 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1710 if [[ ${op} == "-i" ]] ; then 1386 if [[ ${op} == "-i" ]] ; then
1711 hasq ${f} ${ls} && newls="${newls} ${f}" 1387 has ${f} ${ls} && newls="${newls} ${f}"
1712 else 1388 else
1713 hasq ${f} ${ls} || newls="${newls} ${f}" 1389 has ${f} ${ls} || newls="${newls} ${f}"
1714 fi 1390 fi
1715 done 1391 done
1716 ls=${newls} 1392 ls=${newls}
1717 done 1393 done
1718 else 1394 else
1720 fi 1396 fi
1721 1397
1722 nols="" 1398 nols=""
1723 newls="" 1399 newls=""
1724 for f in ${LINGUAS} ; do 1400 for f in ${LINGUAS} ; do
1725 if hasq ${f} ${ls} ; then 1401 if has ${f} ${ls} ; then
1726 newls="${newls} ${f}" 1402 newls="${newls} ${f}"
1727 else 1403 else
1728 nols="${nols} ${f}" 1404 nols="${nols} ${f}"
1729 fi 1405 fi
1730 done 1406 done
1785 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1461 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1786 ewarn "in order to remove these old dependencies. If you do not have this" 1462 ewarn "in order to remove these old dependencies. If you do not have this"
1787 ewarn "helper program, simply emerge the 'gentoolkit' package." 1463 ewarn "helper program, simply emerge the 'gentoolkit' package."
1788 ewarn 1464 ewarn
1789 fi 1465 fi
1466 # temp hack for #348634 #357225
1467 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1790 ewarn " # revdep-rebuild --library ${lib##*/}" 1468 ewarn " # revdep-rebuild --library '${lib}'"
1791 done 1469 done
1792 if [[ ${notice} -eq 1 ]] ; then 1470 if [[ ${notice} -eq 1 ]] ; then
1793 ewarn 1471 ewarn
1794 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1472 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1795 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1473 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1941 else 1619 else
1942 newbin "${tmpwrapper}" "${wrapper}" || die 1620 newbin "${tmpwrapper}" "${wrapper}" || die
1943 fi 1621 fi
1944} 1622}
1945 1623
1946# @FUNCTION: prepalldocs 1624# @FUNCTION: path_exists
1947# @USAGE: 1625# @USAGE: [-a|-o] <paths>
1948# @DESCRIPTION: 1626# @DESCRIPTION:
1949# Compress files in /usr/share/doc which are not already 1627# Check if the specified paths exist. Works for all types of paths
1950# compressed, excluding /usr/share/doc/${PF}/html. 1628# (files/dirs/etc...). The -a and -o flags control the requirements
1951# Uses the ecompressdir to do the compression. 1629# of the paths. They correspond to "and" and "or" logic. So the -a
1952# 2009-02-18 by betelgeuse: 1630# flag means all the paths must exist while the -o flag means at least
1953# Commented because ecompressdir is even more internal to 1631# one of the paths must exist. The default behavior is "and". If no
1954# Portage than prepalldocs (it's not even mentioned in man 5 1632# paths are specified, then the return value is "false".
1955# ebuild). Please submit a better version for review to gentoo-dev 1633path_exists() {
1956# if you want prepalldocs here. 1634 local opt=$1
1957#prepalldocs() { 1635 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1958# if [[ -n $1 ]] ; then
1959# ewarn "prepalldocs: invalid usage; takes no arguments"
1960# fi
1961 1636
1962# cd "${D}" 1637 # no paths -> return false
1963# [[ -d usr/share/doc ]] || return 0 1638 # same behavior as: [[ -e "" ]]
1639 [[ $# -eq 0 ]] && return 1
1964 1640
1965# find usr/share/doc -exec gzip {} + 1641 local p r=0
1966# ecompressdir --ignore /usr/share/doc/${PF}/html 1642 for p in "$@" ; do
1967# ecompressdir --queue /usr/share/doc 1643 [[ -e ${p} ]]
1968#} 1644 : $(( r += $? ))
1645 done
1646
1647 case ${opt} in
1648 -a) return $(( r != 0 )) ;;
1649 -o) return $(( r == $# )) ;;
1650 esac
1651}
1652
1653# @FUNCTION: in_iuse
1654# @USAGE: <flag>
1655# @DESCRIPTION:
1656# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1657# as necessary.
1658#
1659# Note that this function should not be used in the global scope.
1660in_iuse() {
1661 debug-print-function ${FUNCNAME} "${@}"
1662 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1663
1664 local flag=${1}
1665 local liuse=( ${IUSE} )
1666
1667 has "${flag}" "${liuse[@]#[+-]}"
1668}
1669
1670# @FUNCTION: use_if_iuse
1671# @USAGE: <flag>
1672# @DESCRIPTION:
1673# Return true if the given flag is in USE and IUSE.
1674#
1675# Note that this function should not be used in the global scope.
1676use_if_iuse() {
1677 in_iuse $1 || return 1
1678 use $1
1679}
1680
1681# @FUNCTION: usex
1682# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1683# @DESCRIPTION:
1684# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1685# otherwise echo [false output][false suffix] (defaults to "no").
1686usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.349  
changed lines
  Added in v.1.369

  ViewVC Help
Powered by ViewVC 1.1.20